org.apache.tomcat.util.bcel.classfile

## Class LineNumber

- java.lang.Object
- - org.apache.tomcat.util.bcel.classfile.LineNumber

All Implemented Interfaces:
  Serializable, Cloneable

    public final class LineNumber
    extends Object
    implements Cloneable, Serializable

This class represents a (PC offset, line number) pair, i.e., a line number in the source that corresponds to a relative address in the byte code. This is used for debugging purposes.

Author:
  M. Dahm
See Also:
  `LineNumberTable`, Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`LineNumber(int start_pc, int line_number)`

### Method Summary

Methods
`LineNumber` `copy()`
`void` `dump(DataOutputStream file)` Dump line number/pc pair to file stream in binary format.
`String` `toString()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### LineNumber

    public LineNumber(int start_pc,
              int line_number)

Parameters:
  `start_pc` - Program Counter (PC) corresponds to
  `line_number` - line number in source file

### Method Detail

#### dump

    public final void dump(DataOutputStream file)
                    throws IOException

Dump line number/pc pair to file stream in binary format.

Parameters:
  `file` - Output file stream
Throws:
  `IOException`

#### toString

    public final String toString()

Overrides:
  `toString` in class `Object`
Returns:
  String representation

#### copy

    public LineNumber copy()

Returns:
  deep copy of this object